--
--  SearchTidBITSAppDelegate.applescript
--  SearchTidBITS
--
--  Created by Matt Neuburg on 9/3/09.
--  Copyright 2009 __MyCompanyName__. All rights reserved.
--

script SearchTidBITSAppDelegate
	
	# bound from text fields
	property theTitle : ""
	property theAuthor : "Neuburg"
	property theContent : ""
	
	# outlet to objc class
	property amigo : missing value
	
	# outlets to interface
	property results : missing value
	property progress : missing value
	property resultsWindow : missing value
	
	# action of search button
	on doSearch_(sender)
		# validate (crudely)
		set valid to false
		repeat with s in {theTitle, theAuthor, theContent}
			if (s as string) is not in {"", "missing value"} then
				set valid to true
			end if
			if (s as string) begins with " " then
				set valid to false
				exit repeat
			end if
		end repeat
		if not valid then
			beep
			return
		end if
		# start user feedback, do Internet interaction
		tell my resultsWindow to orderOut_(me)
		tell my progress to startAnimation_(me)
		tell current application's class "NSBundle"
			tell its mainBundle()
				set s to its pathForResource_ofType_("searchtb", "rb")
			end tell
		end tell
		try
			set res to do shell script "ruby " & quoted form of (s as string) & space & ¬
				quoted form of (theTitle as string) & space & quoted form of (theAuthor as string) & space & ¬
				quoted form of (theContent as string)
		on error what
			log what
			tell my progress to stopAnimation_(me)
			tell my amigo to fatalError() # easy to call into obj-c code
		end try
		tell my progress to stopAnimation_(me)
		# display results if any (bail and beep otherwise)
		set res to (get every paragraph of res)
		set u to count res
		if u < 2 then
			beep
			return
		end if
		tell current application's class "NSMutableArray"
			set arr to its arrayWithCapacity_(u)
		end tell
		repeat with i from 1 to u by 2
			tell current application's class "NSMutableDictionary"
				# note use of "missing value" to mean "nil"
				set entry to its dictionaryWithObjectsAndKeys_(item i of res, "title", item (i + 1) of res, "url", missing value)
			end tell
			tell arr to addObject_(entry)
		end repeat
		tell my results to setContent_(arr)
		tell my resultsWindow to makeKeyAndOrderFront_(me)
	end doSearch_
	
	# double click in table view
	on doDoubleClick_(theUrl)
		open location ("http://www.tidbits.com" & theUrl)
	end doDoubleClick_
	
	# scriptability
	on application_delegateHandlesKey_(sender, theKey)
		return theKey is in {"theTitle", "theAuthor", "theContent"}
	end application_delegateHandlesKey_
	
end script